Program Check_OB;

uses
    Dos;

var
   OBDirName : PathStr;
   CON : text;
   ErrorLevel : byte;

function UpCaseStr(str : string) : string;
var
   i : byte;
   s : string;
begin
     s := '';
     for i := 1 to Length(str)
         do s := s + UpCase(str[i]);
     UpCaseStr := s;
end;


procedure CheckFile(loFileName : PathStr);

const
     loChars = [#$00, #$0A, #$0D, #$1A, '!'..'', ''..''];
     SrvChrs = ['#', '^'];

var
   loFile : text;
   OBFile : file;
   OBFileName : PathStr;
   i, line : integer;
   Result : boolean;

begin
     Assign(loFile, loFileName);
{$I-}ReSet(loFile);{$I+}
     if IOResult <> 0
        then begin
                  WriteLn(CON, 'Error open file ', loFileName);
                  WriteLn('Del ', loFileName);
             end
        else begin
                  line := 0;
                  while not EOF(loFile)
                        do begin
                                Inc(line);
                                ReadLn(loFile, OBFileName);
                                if OBFileName[1] in SrvChrs
                                   then Delete(OBFileName, 1, 1);
                                Result := true;
                                for i := 1 to Length(OBFileName)
                                    do Result := Result and
                                                 (OBFileName[i] in loChars);
                                if Result
                                   then begin
                                             Assign(OBFile, OBFileName);
                                        {$I-}ReSet(OBFile);{$I+}
                                             Result := Result and
                                                       (IOResult = 0);
                                             if not Result
                                                then begin
                                                          WriteLn(CON, 'Error open file ', OBFileName);
                                                          {$IFDEF OS2}
                                                          WriteLn('DelLine2.exe ', line, ' ', loFileName);
                                                          {$ELSE}
                                                          WriteLn('DelLine.exe ', line, ' ', loFileName);
                                                          {$ENDIF}
                                                          ErrorLevel := 253;
                                                     end
                                                else Close(OBFile);
                                        end
                                   else begin
                                             WriteLn(CON, 'Error in filename ', OBFileName);
                                             {$IFDEF OS2}
                                             WriteLn('DelLine2.exe ', line, ' ', loFileName);
                                             {$ELSE}
                                             WriteLn('DelLine.exe ', line, ' ', loFileName);
                                             {$ENDIF}
                                        end;
                           end;
             end;
     Close(loFile);
end;


procedure CheckDir(OBDirStr : PathStr);

var
   lo, loDirectory : SearchRec;
   loFileName, loMask : PathStr;
   loDir, loFileDir : DirStr;
   loName : NameStr;
   loExt : ExtStr;

begin
      if (OBDirStr[Length(OBDirStr)] = '\') or
         (OBDirStr[Length(OBDirStr)] = ':')
         then loDir := OBDirStr
         else loDir := OBDirStr + '\';
      loMask := loDir + '*.?lo';
      FindFirst(loMask, AnyFile, lo);
      if DosError <> 0
         then begin
                   WriteLn(CON, 'No files matching ', loMask);
                   ErrorLevel := 254;
              end;
      while (DosError = 0)
            do begin
                    FSplit(lo.Name, loFileDir, loName, loExt);
                    loFileName := loDir + lo.Name;
                    if (lo.Attr and Directory = 0) and
                       (lo.Attr and VolumeID = 0)
                       then CheckFile(loFileName);
                    FindNext(lo);
               end;
end;


begin                      { + + + + + Main + + + + + }
     Assign(CON, 'CON');
     ReWrite(CON);
     WriteLn(CON);
     If (ParamStr(1) = '')
        then begin
                  WriteLn(CON, 'Usage: ' + ParamStr(0) +
                          ' [BinkStyleOutBoundDir]');
                  WriteLn(CON);
                  WriteLn(CON, 'This program checks Bink-Style OutBound .?lo-files for proper');
                  WriteLn(CON, 'file names inside them and outputs to stdout sample batch file');
                  WriteLn(CON, 'for killing/correcting corrupted .?lo-files.');
                  WriteLn(CON);
                  WriteLn(CON, 'This program may be useful for checking if the any is corruptted');
                  WriteLn(CON, 'after every system crash.');
                  WriteLn(CON);
                  WriteLn(CON, '(c) CopyLeft Vurdalak, 2:463/323@fidonet.org (Year#2000)');
                  WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel 1');
                  Halt(1);
             end;
     OBDirName := ParamStr(1);
     ErrorLevel := 0;
     WriteLn(CON, 'Running: ', ParamStr(0), ' ', OBDirName);
     CheckDir(OBDirName);
     WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel ', ErrorLevel);
     Halt(ErrorLevel);
end.
