Program Tic_OK;

uses
    Dos;

label
     ErRec;

var
   SetUpFileName, TicFileName, FileSubjName, TicMask : PathStr;
   SetUpFile, TicFile, FileSubj, CON : text;
   TicAreaName, AreaName, AreaPath : DirStr;
   TmpStr, TicPw, PassWord, Node : string;
   TicDir : DirStr;
   TicName : NameStr;
   TicExt : ExtStr;
   Tic : SearchRec;
   ErrorLevel : byte;
   RecErr : boolean;

function UpCaseStr(str : string) : string;
var
   i : byte;
   s : string;
begin
     s := '';
     for i := 1 to Length(str)
         do s := s + UpCase(str[i]);
     UpCaseStr := s;
end;


procedure TicFileErr;
begin
     If EOF(TicFile)
        then begin
                  WriteLn(CON, 'Error in .tic file ' +
                          TicFileName + ': Record not found :-(');
                  Errorlevel := 253;
                  RecErr := true;
             end;
end;

procedure SetUpFileErr;
begin
     If EOF(SetUpFile)
        then begin
                  WriteLn(CON, FExpand(TicFileName),
                               ': Error in SetUp.Txt file of AllFix: ',
                               'Record not found :-(');
                  Errorlevel := 252;
                  RecErr := true;
             end;
end;


begin                      { + + + + + Main + + + + + }
     Assign(CON, 'CON');
     ReWrite(CON);
     WriteLn(CON);
     If ParamStr(1) = ''
        then begin
                  WriteLn(CON, 'Usage: ' + ParamStr(0) +
                          ' [SetUp.Txt_File [Tic_File_Mask]]');
                  WriteLn(CON);
                  WriteLn(CON, 'This program takes data from SetUp.Txt file generated by ASetUp export');
                  WriteLn(CON, 'menu and from .tic files generated by AllFix to recover path and');
                  WriteLn(CON, 'destination of file echo files. This is Greatest help when your');
                  WriteLn(CON, '.?lo files were erased, but you want to be downlinks happy ;-)');
                  WriteLn(CON, 'But: you must have unique password(s) for every downlink :-(');
                  WriteLn(CON);
                  WriteLn(CON, 'This program generates batch file line(s) for people using');
                  WriteLn(CON, 'T-Mail and MakeBox utility for it. Using a stdout of a program');
                  WriteLn(CON, 'any hi-end user of FTN-platform may be satisfacted ;-)');
                  WriteLn(CON);
                  WriteLn(CON, '(c) CopyLeft Vurdalak, 2:463/323@fidonet.org (Year#2000)');
                  WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel 1');
                  Halt(1);
             end;
     SetUpFileName := ParamStr(1);
     TicMask := ParamStr(2);
     if TicMask = ''
        then TicMask := '*.tic'
        else FSplit(TicMask, TicDir, TicName, TicExt);
     FindFirst(TicMask, AnyFile, Tic);
     if Tic.Attr = Directory
        then begin
                  TicMask := TicDir + TicName + TicExt + '\';
                  TicName := '';
                  TicExt := '';
             end;
     if TicName = ''
        then TicMask := TicMask + '*';
     if TicExt = ''
        then TicMask := TicMask + '.tic';
     TicFileName := TicMask;
     WriteLn(CON, 'Running: ', ParamStr(0), ' ', SetUpFileName, ' ', TicMask);
     If (DosError <> 0)
        then begin
                  WriteLn(CON, 'Error open .tic file ' + TicFileName);
                  WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel 254');
                  Halt(254);
             end;
     ErrorLevel := 0;
  while DosError = 0 do
   begin
     TicFileName := TicDir + Tic.Name;
     FSplit(TicFileName, TicDir, TicName, TicExt);
     Assign(TicFile, TicFileName);
{$I-}ReSet(TicFile);{$I+}
     If (IOResult <> 0) or
        (TicName = '') or
        (TicExt = '')
        then begin
                  WriteLn(CON, 'Error open .tic file ' + TicFileName);
                  WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel 254');
                  Halt(254);
             end;
     TicAreaName := '';
     FileSubjName := '';
     TicPw := '';
     repeat
           TicFileErr;
           ReadLn(TicFile, TmpStr);
           If UpCaseStr(Copy(TmpStr, 1, 5)) = 'AREA '
              then TicAreaName := Copy(TmpStr, 6,  Length(TmpStr) - 5);
           If UpCaseStr(Copy(TmpStr, 1, 5)) = 'FILE '
              then FileSubjName := Copy(TmpStr, 6,  Length(TmpStr) - 5);
           If UpCaseStr(Copy(TmpStr, 1, 3)) = 'PW '
              then TicPw := Copy(TmpStr, 4,  Length(TmpStr) - 3);
     until EOF(TicFile);
     If (TicAreaName = '') or
        (FileSubjName = '') or
        (TicPw = '')
        then TicFileErr;
     if RecErr
        then GoTo ErRec;
     Assign(SetUpFile, SetUpFileName);
{$I-}ReSet(SetUpFile);{$I+}
     If IOResult <> 0
        then begin
                  WriteLn(CON, 'Error open SetUp.Txt file of AllFix');
                  WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel 255');
                  Halt(255);
             end;
     repeat
           SetUpFileErr;
           ReadLn(SetUpFile, TmpStr);
     until UpCaseStr(Copy(TmpStr, 1, 11)) = '[FILE ECHO]';
     if RecErr
        then GoTo ErRec;
     AreaName := '';
     AreaPath := '';
     repeat
           SetUpFileErr;
           ReadLn(SetUpFile, TmpStr);
           If UpCaseStr(Copy(TmpStr, 1, 5)) = 'TAG="'
              then begin
                        AreaName := Copy(TmpStr, 6,  Length(TmpStr) - 6);
                        AreaPath := '';
                   end;
           If UpCaseStr(Copy(TmpStr, 1, 6)) = 'DEST="'
              then AreaPath := Copy(TmpStr, 7,  Length(TmpStr) - 7);
     until (AreaPath <> '') and
           (UpCaseStr(AreaName) = UpCaseStr(TicAreaName));
     if RecErr
        then GoTo ErRec;
     repeat
           SetUpFileErr;
           ReadLn(SetUpFile, TmpStr);
     until UpCaseStr(Copy(TmpStr, 1, 21)) = '[NODE MANAGER SYSTEM]';
     SetUpFileErr;
     if RecErr
        then GoTo ErRec;
     Node := '';
     PassWord := '';
     repeat
           SetUpFileErr;
           ReadLn(SetUpFile, TmpStr);
           If UpCaseStr(Copy(TmpStr, 1, 7)) = 'SYSTEM='
              then Node := Copy(TmpStr, 8,  Length(TmpStr) - 7);
           If UpCaseStr(Copy(TmpStr, 1, 19)) = 'FILEECHO PASSWORD="'
              then PassWord := Copy(TmpStr, 20,  Length(TmpStr) - 20);
     until (Node <> '') and
           (UpCaseStr(PassWord) = UpCaseStr(TicPw));
     SetUpFileErr;
     if RecErr
        then GoTo ErRec;
     WriteLn('MakeBox '+ Node + ' ' + AreaPath + FileSubjName);
     WriteLn('MakeBox '+ Node + ' ' + FExpand(TicFileName) + ' /M');
  ErRec:
     RecErr := false;
     Close(TicFile);
     Close(SetUpFile);
     FindNext(Tic);
   end;
     WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel ', ErrorLevel);
     Halt(ErrorLevel);
end.